module Gallery
  class Engine < ::Rails::Engine
  	initializer "gallery" do
  		OrbitApp.registration "Gallery", :type => "ModuleApp" do
  			module_label "gallery.gallery"
        	base_url File.expand_path File.dirname(__FILE__)
          widget_methods ["widget"]
          # widget_settings []
          widget_settings [{"data_count"=>10}]
          models_to_cache [:album,:album_image]
        	categorizable
        	authorizable
          frontend_enabled
          data_count 1..30
        	side_bar do
        		head_label_i18n 'gallery.gallery', icon_class: "icons-pictures"
          		available_for "users"
          		active_for_controllers (['admin/galleries','admin/images'])
          		head_link_path "admin_galleries_path"

              context_link 'gallery.all',
                :link_path=>"admin_galleries_path" ,
                :priority=>1,
                :active_for_action=>{'admin/galleries'=>"index"},
                :available_for => 'users'

              context_link 'gallery.new',
                :link_path=>"new_admin_gallery_path" ,
                :priority=>2,
                :active_for_action=>{'admin/galleries'=>"new"},
                :available_for => 'sub_managers'

              context_link 'categories',
                :link_path=>"admin_module_app_categories_path" ,
                :link_arg=>"{:module_app_id=>ModuleApp.find_by(:key=>'gallery').id}",
                :priority=>3,
                :active_for_action=>{'admin/galleries'=>'categories'},
                :active_for_category => 'Gallery',
                :available_for => 'managers'
                                
              context_link 'tags',
                :link_path=>"admin_module_app_tags_path" ,
                :link_arg=>"{:module_app_id=>ModuleApp.find_by(:key=>'gallery').id}",
                :priority=>4,
                :active_for_action=>{'admin/galleries'=>'tags'},
                :active_for_tag => 'Gallery',
                :available_for => 'managers'
        	end
  		end
  	end
  end
end
